/* (C) 2000-2001 Grafixoft Email a@oo.ms */
/* see file COPYRIGHT for info */

/*
 GSM spew ...

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <sys/ioctl.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <string.h>
#include <linux/soundcard.h>

#define TX

#include "gsm2.h"
extern int recode(char *src, char *dest, int style, int data, int code);
extern int openstream(int style,int way, int dspspeed);

int tx(int audiost)
{
	int lastdsp=0;
	int lastaudiostyle=0;
	int dsp=8000;
	int a=0;
	char keyin=0;
	unsigned long long bytes=0;
	time_t oldtime, newtime, lasttime;
	int i, t;
	int retval;
	unsigned char datapack[BGSM+2];
	unsigned char *outpack;
	char other[20];
	int audopen=0;
	char *puke;
	int audiostyle=audiost & 0xff;

	/* if(audiostyle >= 0x80) dsp=22500; */
	dodo=sizepack;
	packages=6;
	blocksgsm=packages * 33;
	blocksau=packages * 160;
	outpack=datapack;
	puke=outpack;
	*puke=0x04;
	puke++;
	*puke=audiostyle & 0xff;
	write(sock,outpack,2);
	newtime = time(NULL);
	oldtime=newtime;
	lasttime=newtime;
	for(;;) {

		/*
		read from host, display any incoming text
		useful for debuging, prolly good for telling other
		side to shut up and give other side a chance.
		Also has many other uses... to many to list here.
		*/
		key=0;
		decider=0;
		
		if(onfile != 0) {
			if (audopen==0) {
				audiostyle=openstream(audiostyle,0,dsp);
				packages=6;
				blocksgsm=packages * 33;
				blocksau=packages * 160;
				sprintf(other,"\010%c%c%c",(dsp)&0xff,(dsp>>8)&0xff,audiostyle);
				write(sock,(void *)&other,4);
				sprintf(other,"\004%c",audiostyle&0xff);
				write(sock,(void *)&other,2);
				audopen=1;
			}
		} else {
			FD_ZERO(&rd);
			FD_SET(sock,&rd);
			(void) select (FD_SETSIZE, &rd, NULL, NULL, &mydelay);
			if(FD_ISSET(sock,&rd)) {
				read (sock, (void *)&decider, 1);
			
				/* needed badly for video and shit :-) */
					
				switch(decider & 0xff) {
					case 0:
						printf("Remote requested disconnect\n");
						cclosed();
						return(3);
						break;
			
					case 1: /* rx/tx turnaround */
						return(0); /* modus return */
						break;
					
					case 2: /* inbound text */
						read(sock,(void *) &keyin, 1);
						bytes++;
						if( (keyin < 32) && (keyin != 10) && (key != 8)) keyin=32;
						printf("%c",keyin);
						fflush(stdout);
						break;

					case 3: /* gsm packages, toss them :-) */
						read(sock,(void *) &keyin, 1);
						bytes++;
						packs=keyin & 0xff;
						kanker=buffie;
	
						for(i=0;i<packs*33;) {
							a=read(sock, (void *)kanker, (packs*33)-i);
							i+=a;
							kanker+=a;
							bytes+=a;
						}
						break;


					case 4: /* audio type handshake, this will determine lowest common method */
						lastaudiostyle=audiostyle;
						read(sock,(void *) &audiostyle, 1);
						bytes++;
						audiostyle=audiostyle & 0xff;
						if ((audopen == 1) && ((dsp != lastdsp) || (audiostyle != lastaudiostyle))) {
							lastdsp=dsp;
							close(audiostream);
							a=openstream(audiostyle,0,dsp);
							if(a != audiostyle) {
								audiostyle=a;
								close(audiostream);
								outpack=datapack;
								puke=outpack;
								*puke=0x04;
								puke++;
								*puke=audiostyle & 0xff;
								write(sock,outpack,2);
							} else {
								audopen=1;
								audiostyle=a;
							}
						} else {
							if (audopen == 0) {
								lastdsp=dsp;
								a=openstream(audiostyle,0,dsp);
								if(a != audiostyle) {
									audiostyle=a;
									close(audiostream);
									outpack=datapack;
									puke=outpack;
									*puke=0x04;
									puke++;
									*puke=audiostyle & 0xff;
									write(sock,outpack,2);
								} else {
									audopen=1;
									audiostyle=a;
								}
							}
						}
						break;

					case 5:
						if (audopen==1) close(audiostream);
						audopen=0;
						dsp+=DSPCHANGE;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						sprintf(other,"\005");
						write(sock,(void *)&other,1);
						break;
						
					case 6:
						if (audopen==1) close(audiostream);
						audopen=0;
						dsp-=DSPCHANGE;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						sprintf(other,"\006");
						write(sock,(void *)&other,1);
						break;
					
					case 7: /* stereo flip request, no dsp adjust */
						read(sock,(void *) &audiostyle, 1);
						bytes++;
						audiostyle=audiostyle & 0xff;
						if (audopen==1) close(audiostream);
						audopen=0;
						/* other side will request with 0x04 */
						break;
				
					case 8:
						/* dsp speed force request/stereo flip data sync request */
						read(sock,(void *) &dsp, 2);
						read(sock,(void *) &audiostyle, 1);
						bytes+=3;
						if (audopen==1) close(audiostream);
						/* FORCE adjust dsp speed */
						audopen=0;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						sprintf(other,"\004%c",audiostyle&0xff);
						write(sock,(void *)&other,2);
						break;

					case 9:
						read(sock,(void *) &dsp, 2);
						read(sock,(void *) &audiostyle, 1);
						bytes+=3;
						if (audopen==1) close(audiostream);
						/* FORCE a _REQUEST_ for adjust dsp speed sync */
						sprintf(other,"\010%c%c%c",(dsp)&0xff,(dsp>>8)&0xff,audiostyle);
						write(sock,(void *)&other,4);
						audopen=0;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						break;

					case 10:
						read(sock, &t, 1);
						packages=t & 0xff;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						printf("\n\npackages now @ %i\n",packages);
						break;
						
					default: /* huh?? */
						break;
				}
			}
		}

		newtime = time(NULL);
		if(bytes == 0) {
			/* sync */
			lasttime=newtime;
			oldtime=newtime;
		}
		/* input from term... spew to remote :-) */
		key=0;
		FD_ZERO(&rd);
		FD_SET(fileno(stdin),&rd);
		(void) select (FD_SETSIZE, &rd, NULL, NULL, &mydelay);
		
		if(onfile != 0) {
			/* check for exit (^A), other stuff soon to come... */
			if(FD_ISSET(fileno(stdin),&rd)) {
				read (fileno(stdin),(void *)&key, 1);
				switch(key) {
					case 1:
						write(sock,"\000",1);
						cclosed();
						return(3);
						break;

					default:
						if((key < 32) && (key != 10) && (key != 8)) key=32;
						printf("%c",key);
						sprintf(other,"\002%c",key);
						fflush(stdout);
						write(sock,(void *)&other,2);
						break;
			
				}
			}
			
		} else {
			/* check for exit (^A), other stuff soon to come... */
			if(FD_ISSET(fileno(stdin),&rd)) {
				read (fileno(stdin),(void *)&key, 1);
				switch(key) {
					case 1:
						write(sock,"\000",1);
						sleep(2);
						cclosed();
						return(3);
						break;

					case 2: /* perform rx/tx turnaround */
						write(sock,"\001",1);
						return(0);
						break;
	
					case 9:
						if(bytes > 0) {
							printf("RW bandwidth: %.2f bytes/sec, time %lu:%2.2lu, bytes %llu       ",(float)bytes/(newtime-oldtime),(newtime-oldtime)/60,(newtime-oldtime)-(((newtime-oldtime)/60)*60),bytes);
							printf("\n");
						} else {
							printf("No data yet!\n");
						}
						break;

					/* FORCE data rate changes */
					case 21: /* ^U */
						write(sock,"\005",1);
						if (audopen==1) close(audiostream);
						audopen=0;
						dsp+=DSPCHANGE;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						break;
				
					case 25: /* ^Y */
						write(sock,"\006",1);
						if (audopen==1) close(audiostream);
						audopen=0;
						dsp-=DSPCHANGE;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						break;
				
					case 24: /* ^X */
						if (audopen==1) close(audiostream);
						/* FORCE a _REQUEST_ for adjust dsp speed */
						if(audiostyle < 0x80 ) {
							dsp=dsp/2;
						} else {
							dsp=dsp*2;
						}
						audiostyle=audiostyle ^ 0x80;
						sprintf(other,"\010%c%c%c",(dsp)&0xff,(dsp>>8)&0xff,audiostyle);
						write(sock,(void *)&other,4);
						audopen=0;
						packages=6;
						blocksgsm=packages * 33;
						blocksau=packages * 160;
						break;
					
					default:
						if((key < 32) && (key != 10) && (key != 8)) key=32;
						printf("%c",key);
						sprintf(other,"\002%c",key);
						fflush(stdout);
						write(sock,(void *)&other,2);
						break;
			
				}
			}
		}
		if (audopen==1) {
			/* suck in blocksau byte audio packages */
			retval=0;
			retval=recode((char *)&audio,(char *)&linearbuf,audiostyle,packages,0);
			if(retval==0) {
				/* encode 320 bytes -> 33 bytes */
				src=(char *)linearbuf;
				puke=pack;
				/* do left and right independently */
				if(audiostyle<0x80) {
					for(scp=0;scp<packages;scp++) {
						gsm_encode(gsmh, (short *)src, dst);
						bcopy(dst, puke, 33);
						puke+=33;
						src+=320;
					}
				} else {
					for(scp=0;scp<(packages/2);scp++) {
						gsm_encode(gsmh, (short *)src, dst);
						bcopy(dst, puke, 33);
						puke+=33;
						src+=320;
					}
					for(;scp<packages;scp++) {
						gsm_encode(hndle, (short *)src, dst);
						bcopy(dst, puke, 33);
						puke+=33;
						src+=320;
					}
				}
	
				/* puke gsm package to socket */
				bcopy(pack,outpack+2,blocksgsm);
				puke=outpack;
				*puke=0x03;
				puke++;
				*puke=packages & 0xff;
				write(sock,outpack,blocksgsm+2);
				bytes+=blocksgsm+2;
	
				if(onfile != 0) { 
					if ((newtime-oldtime)>0) printf("\rRW bandwidth: %.2f bytes/sec, time %lu:%2.2lu, bytes %llu       ",(float)bytes/(newtime-oldtime),(newtime-oldtime)/60,(newtime-oldtime)-(((newtime-oldtime)/60)*60),bytes);
					fflush(stdout);
				}
			}  else { 
				/* Record says we need a change, drop/raise rate if we can! */
				/* If not, just try to resync. */
				if (audopen==1) close(audiostream);
				dsp=dsp+(500*retval);
				if (dsp<4000) dsp=4000;
				if(dsp>44000) dsp=44000;
				/* FORCE a _REQUEST_ for adjust dsp speed sync */
				sprintf(other,"\010%c%c%c",(dsp)&0xff,(dsp>>8)&0xff,audiostyle);
				write(sock,(void *)&other,4);
				audopen=0;
				packages=6;
				blocksgsm=packages * 33;
				blocksau=packages * 160;
			} /* record autodsp adjust */
		} /* audopen==1 */
	} /* for(;;) */
}
